$("#submit").click(function(){
    var a = {
        name: $("#a-name").val(),
        surname: $("#a-surname").val(),
    }
    var b = {
        name: $("#b-name").val(),
        surname: $("#b-surname").val(),
    }
    var c = {
        name: $("#c-name").val(),
        surname: $("#c-surname").val(),
    }

    a.age = +$("#a-age").val();
    b.fathername = $("#b-fathername").val();
    c.sex = $("#c-sex").val();

    var persons = [a,b,c,
        {
            name: $("#p-name").val(),
            surname: $("#p-surname").val(),
            age: +$("#a-age").val()
        }
    ]

    document.write("<table cellpadding = 5>");
document.write("<tr>");
for (var i = 0; i < persons.length - 2; i++) {
    var br;
    br = false;
    var key = Object.keys(persons[i]);
    for (var j = 0; j < persons.length; j++) {
        var keyy = Object.keys(persons[j]);
        if(key[i] !== keyy[i]) // Проверяю совпадает ли ключ объкта с ключами остальных, если нет то заголовок не выводится 
            br = true;
    }
    if(br)
        document.write("<th></th>");
    else{
        document.write("<th></th>");
        $("th:nth-of-type(" + (i + 1) + ")").html(key[i]);
    }
}
document.write("</tr>");
    
for (var i = 0; i < persons.length; i++) {
    var key = Object.keys(persons[i]);
    
    if(!(i % 2))
        document.write("<tr style = 'background: #ccc;'>");
    else
        document.write("<tr>");
   
    for (var c = 0; c < key.length; c++) {
            document.write("<td></td>");
            $("tr:nth-of-type("+ (i + 2) +") td:nth-of-type("+ (c + 1) +")").html(persons[i][key[c]]);

    }
    document.write("</tr>");
}
document.write("</table>");

    return false;
});

